#include <PalmOS.h>


enum BackupOpType {
	BackupStarting,
	BackupCopying,
	BackupDeleting,
	BackupDone,
};

typedef Err (*BackupFailHandlerF)(void *userData, const char *name, Err e);
typedef Err (*BackupProgressF)(void *userData, enum BackupOpType op, UInt16 idx, UInt16 of, UInt32 size, UInt32 sizeOf, const char *name);
typedef Err (*BackupEnumF)(void *userData, const char *name);

//operation on a backup set
Err backupDo(UInt16 vrn, const char *bkpName, BackupProgressF progressF, BackupFailHandlerF errF, void *progressD);		//path is dir we'll create
Err backupRestore(UInt16 vrn, const char *bkpName, BackupProgressF progressF, BackupFailHandlerF errF, void *progressD);
Err backupDelete(UInt16 vrn, const char *bkpName, BackupProgressF progressF, void *progressD);
Err backupRename(UInt16 vrn, const char *bkpName, const char *newName);


//enumeration of sets (do not call other backsup funcs in callback. error returned from callback terminates enumeration and is returned)
Err backupEnumerate(UInt16 vrn, BackupEnumF enumF, void *enumD);