#include <PalmOS.h>


struct ItemInfo {
	UInt16 cardNo;
	LocalID LID;
};

void __Startup__(void)
{
	MemHandle mh = MemHandleNew(1);
	UInt16 i, j, cardNo, num = 0;
	DmSearchStateType ss;
	Boolean first = true;
	struct ItemInfo *ii;
	LocalID LID;
	
	if (!mh)
		return;
	
	//make a list
	while (errNone == DmGetNextDatabaseByTypeCreator(first, &ss, 'extx', NULL, true, &cardNo, &LID)) {
		
		if (errNone != MemHandleResize(mh, (num + 1) * sizeof(struct ItemInfo)))
			break;
		
		ii = ((struct ItemInfo*)MemHandleLock(mh)) + num++;
		ii->cardNo = cardNo;
		ii->LID = LID;
		MemHandleUnlock(mh);
		
		first = false;
	}
	
	//use it
	ii = (struct ItemInfo*)MemHandleLock(mh);
	for (i = 0; i < num; i++, ii++) {
		
		DmOpenRef db = DmOpenDatabase(ii->cardNo, ii->LID, dmModeReadOnly);
		MemHandle res;
		
		if (!db)
			continue;
		
		for (j = 0; (res = DmGet1Resource('extn', j)) != NULL; j++) {
			
			((void (*)(void))MemHandleLock(res))();
			
			MemHandleUnlock(res);
			DmReleaseResource(res);
		}
		
		DmCloseDatabase(db);
	}
	MemHandleUnlock(mh);
	
	//free it
	MemHandleFree(mh);
}
